<?php
class Vpn {
	/* [ATTRIBUTS] */
	private $_m;

	private $_isRequestRejected 	= false,
		$_reasonRejected	= null;

	// list by showed order
	// TODO: set this parameter list into a file stored under modules/Vpn
	//	 to be used by Vpn and vpn_submit
	private $_data 		= array(),
		$_data_list 	= array(
			'iprange' 	=> array(
				'default' 	=> '10.0.0.0',
				'display'	=> 'fieldInput',
				'javaValidator'	=> '{verifyIP: true}',
				'key' 		=> 'iprange',
				'options' 	=> array(),
				'title'		=> 'VPN_DATA_IPRANGE_DIS',
				'tooltip'	=> 'VPN_DATA_IPRANGE_TOOLTIP',
			),
			/*
			'ipaddr' 	=> array(
				'default' 	=> '10.0.0.1',
				'display'	=> 'fieldInput',
				'javaValidator'	=> '{verifyIP: true}',
				'key' 		=> 'ipaddr',
				'options' 	=> array(),
				'title'		=> 'VPN_DATA_IPADDR_DIS',
				'tooltip'	=> 'VPN_DATA_IPADDR_TOOLTIP',
			),
			*/
			'ipnetmask' 	=> array(
				'default' 	=> '255.255.255.0',
				'display'	=> 'fieldInput',
				'javaValidator'	=> '{verifyIP: true}',
				'key' 		=> 'ipnetmask',
				'options' 	=> array(),
				'title'		=> 'VPN_DATA_IPNETMASK_DIS',
				'tooltip'	=> 'VPN_DATA_IPNETMASK_TOOLTIP',
			),
			'port' 		=> array(
				'default' 	=> '1194',
				'display'	=> 'fieldInput',
				'javaValidator'	=> '{range: [1084, 65535]}',
				'key' 		=> 'port',
				'options' 	=> array(),
				'title'		=> 'VPN_DATA_PORT_DIS',
				'tooltip'	=> 'VPN_DATA_PORT_TOOLTIP',
			),
			'protocol' 	=> array(
				'default' 	=> 'UDP',
				'display'	=> 'fieldSelect',
				'javaValidator'	=> false,
				'key' 		=> 'protocol',
				'title'		=> 'VPN_DATA_PROTOCOL_DIS',
				'tooltip'	=> 'VPN_DATA_PROTOCOL_TOOLTIP',
				'options' 	=> array('select' => array('UDP', 'TCP'))
			),
		);

	/* [CONSTRUCTOR] */
        function __construct($m, $get = array(), $post = array(), $session = array()) {
		$this->_m = $m;

		// load beroAri / beroConf classes -> should be avoided and given as argument of the construct method
		require_once('/usr/local/www/berogui/misc/database.php');
		$ba = new beroAri();

		// set data
		$query = $ba->select('SELECT * FROM sbc_vpns');
		while ($entry = $ba->fetch_array($query, SQLITE_ASSOC)) {
			foreach ($this->_data_list as $key => $params) {
				$this->_data[$entry['id']][$key] = $entry[$key];
			}
		}

		// set error
		if (isset($get['error'])) {
			$this->_isRequestRejected = true;
			switch ($get['error']) {
				case '1':
					$this->_reasonRejected = Helper::displayErrorMessage($get['request'], $get['checkor'], $get['key']);
					break;
				case '2':
					$this->_reasonRejected = Helper::displayErrorMessage("Invalid input data: {$get['reason']}");
					break;
				default:
					$this->_reasonRejected = "Unknown error";
					break;
			}
		}
	}

	/* [PUBLIC METHODS] */
	public function display() {
		$name = "VPN_TITLE_DIS";
		include('./includes/header.php');

		// errors
		if ($this->_isRequestRejected) {
			$ret .= $this->_reasonRejected;
		}

		// javascripts tabs
		$ret .=   "\n"
			. "<script>\n"
			. "\t$(function() { $('#tabs').tabs({activate:0}); });\n"
			. "</script>\n";

		// tabs
		require('./includes/Helper/HelperHtml.php');
		$ret .=	  "<div id='vpn_error' class='text-center' style='color: red; font-size: 13px; margin-top: 20px; margin-bottom: -20px;'></div>\n"
			. "<div id='content' style='margin-top:45px;'>\n"
			. "\t<div id='tabs'>\n"
			. "\t\t<ul>\n"
			. "\t\t\t<li><a href='#tabs-1'>". VPN_SETTINGS_TAB ."</a></li>\n"
			. "\t\t\t<li><a href='#tabs-2'>". VPN_CLIENT_CONF_DOWNLOAD_TAB ."</a></li>\n"
			. "\t\t</ul>\n"
			. $this->_displaySettingsTab()
			. $this->_displayDownloadClientConfTab()
			. "\t</div>\n"
			. "</div>\n";

		return $ret;
	}

	/* [PRIVATE METHODS] */
	private function _displayDownloadClientConfTab() {
		ob_start();
		?>
		<!-- Download Client Conf Tab --!>
		<div id='tabs-2'>
			<div class="panel panel-default" style="max-width:600px; margin:auto; margin-top: 20px;">
				<div class="panel-heading text-center lead">
					<?php echo VPN_CLIENT_CONF_DOWNLOAD_DIS ."\n"; ?>
				</div>
				<div class="panel-body text-center">
					<input type='button' class='btn btn-default' value='<?php echo VPN_CLIENT_CONF_DOWNLOAD_BUTTON ?>'
						onclick="window.location.href='misc/files_download.php?option=vpn-client-conf-dl'">
				</div>
			</div>
		</div>
		<?php
		return ob_get_clean() ."\n";
	}

	private function _displaySettingsTab() {
		// display form
		ob_start();
		?>
		<!-- Settings Tab --!>
		<div id='tabs-1'>
			<script type="text/javascript">
				$(document).ready(function () {
					$("#id_vpn_settings").validate({
						rules: {
		<?php
		foreach ($this->_data_list as $key => $params) {
			if ($params['javaValidator']) {
				echo "\t\t\t\t\t\t\t'data[$key]': {$params['javaValidator']},\n";
			}
		}
		?>
						},
					});
					$('#id_vpn_settings').submit(function (evt) {
						// TODO: Does the checkor can be enhanced ?
						var ipRange = $('#id_<?php echo $this->_data_list['iprange']['key']; ?>').val().split('.');
						if (ipRange[3] == '0') {
							var ipNetmask = $('#id_<?php echo $this->_data_list['ipnetmask']['key']; ?>').val().split('.');
							if (ipNetmask[3] == '0') {
								return;
							}
							else {
								$('#vpn_error').html('<?php echo VPN_IPNETMASK_ERROR; ?>');
							}
						}
						else {
							$('#vpn_error').html('<?php echo VPN_IPRANGE_ERROR; ?>');
						}
						evt.preventDefault();
					});
					$('#id_vpn_settings').change(function () {
						$('#vpn_error').html('');
					});
				});
			</script>
			<form name='name_vpn_settings' id='id_vpn_settings' class="form-horizontal" style='magin-bottom:10px;' action='modules/Vpn/vpn_submit.php' method='POST' ENCTYPE="multipart/form-data">
				<input type='hidden' name='idkey' value='0'> 
		<?php
		$ret = ob_get_clean() ."\n";

		foreach ($this->_data_list as $key => $params) {
			$function = $params['display'];
			$ret .= HelperHtml::$function($key, $this->_data[0][$key], $params, "\t\t\t\t");
		}

		ob_start();
		?>
				<div class='text-center'>
					<input name='submit' type='submit' class='btn btn-default' value='<?php echo BUTTON_SAVE ?>'>
				</div>
			</form>
		</div>
		<?php

		return $ret. ob_get_clean() ."\n";
	}
}
?>
